﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Public Class Form1
   Private moShapeFile1 As ShapeFileFeatureLayer
   Private moShapeFile2 As ShapeFileFeatureLayer
   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      txt1.Text = "Note that the project is set to use the Unmanaged Geometry Library (when form loads). Place a breakpoint in btnIntersect_Click. Click the button to " &
                  "to try to get the intersection of the two features. Note that the result is Nothing. Now stop the application and change it to use the Manged Geometry " &
                  "Library. Now the intersection produces a result. I do not believe either of the geomtries is invalid."



      mLoadData()
   End Sub
   Private Sub mLoadData()
      Dim sPath1 As String = "..\..\Data\MyNewLayer.shp"
      Dim sPath2 As String = "..\..\Data\QB 1175SLG Poly.shp"
      Dim sSym1 As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 1)
      Dim sSym2 As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)

      BaseShape.GeometryLibrary = GeometryLibrary.Unmanaged

      moShapeFile1 = New ShapeFileFeatureLayer(sPath1, ShapeFileReadWriteMode.ReadOnly)
      moShapeFile1.Name = "ShapeFile1"
      moShapeFile1.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = sSym1
      moShapeFile1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      moShapeFile2 = New ShapeFileFeatureLayer(sPath2, ShapeFileReadWriteMode.ReadOnly)
      moShapeFile2.Name = "ShapeFile2"
      moShapeFile2.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = sSym2
      moShapeFile2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      Dim oLayers As New LayerOverlay
      oLayers.Layers.Add(moShapeFile1.Name, moShapeFile1)
      oLayers.Layers.Add(moShapeFile2.Name, moShapeFile2)

      WinformsMap1.Overlays.Add(oLayers)

      moShapeFile1.Open()
      WinformsMap1.MapUnit = GeographyUnit.Meter
      WinformsMap1.CurrentExtent = moShapeFile1.GetBoundingBox

      WinformsMap1.Refresh()

   End Sub


   Private Sub btnIntersect_Click(sender As System.Object, e As System.EventArgs) Handles btnIntersect.Click
      Dim oShape1 As AreaBaseShape
      Dim oShape2 As AreaBaseShape

      oShape1 = CType(moShapeFile1.QueryTools.GetFeatureById("1", ReturningColumnsType.AllColumns).GetShape, AreaBaseShape)
      oShape2 = CType(moShapeFile2.QueryTools.GetFeatureById("1", ReturningColumnsType.AllColumns).GetShape, AreaBaseShape)

      Dim oIntersectShape As MultipolygonShape = oShape1.GetIntersection(oShape2)

   End Sub
End Class
